<!DOCTYPE HTML>
<html lang="en" class="sidebar-visible no-js light">
    <head>
        <!-- Book generated using mdBook -->
        <meta charset="UTF-8">
        <title>ADR-003 - Arquitetura Mínima Viável</title>
        <!-- Custom HTML head -->
        <meta content="text/html; charset=utf-8" http-equiv="Content-Type">
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="theme-color" content="#ffffff" />

        <link rel="icon" href="../../../favicon.svg">
        <link rel="shortcut icon" href="../../../favicon.png">
        <link rel="stylesheet" href="../../../css/variables.css">
        <link rel="stylesheet" href="../../../css/general.css">
        <link rel="stylesheet" href="../../../css/chrome.css">
        <link rel="stylesheet" href="../../../css/print.css" media="print">
        <!-- Fonts -->
        <link rel="stylesheet" href="../../../FontAwesome/css/font-awesome.css">
        <link rel="stylesheet" href="../../../fonts/fonts.css">
        <!-- Highlight.js Stylesheets -->
        <link rel="stylesheet" href="../../../highlight.css">
        <link rel="stylesheet" href="../../../tomorrow-night.css">
        <link rel="stylesheet" href="../../../ayu-highlight.css">

        <!-- Custom theme stylesheets -->
    </head>
    <body>
        <!-- Provide site root to javascript -->
        <script type="text/javascript">
            var path_to_root = "../../../";
            var default_theme = window.matchMedia("(prefers-color-scheme: dark)").matches ? "navy" : "light";
        </script>

        <!-- Work around some values being stored in localStorage wrapped in quotes -->
        <script type="text/javascript">
            try {
                var theme = localStorage.getItem('mdbook-theme');
                var sidebar = localStorage.getItem('mdbook-sidebar');

                if (theme.startsWith('"') && theme.endsWith('"')) {
                    localStorage.setItem('mdbook-theme', theme.slice(1, theme.length - 1));
                }

                if (sidebar.startsWith('"') && sidebar.endsWith('"')) {
                    localStorage.setItem('mdbook-sidebar', sidebar.slice(1, sidebar.length - 1));
                }
            } catch (e) { }
        </script>

        <!-- Set the theme before any content is loaded, prevents flash -->
        <script type="text/javascript">
            var theme;
            try { theme = localStorage.getItem('mdbook-theme'); } catch(e) { }
            if (theme === null || theme === undefined) { theme = default_theme; }
            var html = document.querySelector('html');
            html.classList.remove('no-js')
            html.classList.remove('light')
            html.classList.add(theme);
            html.classList.add('js');
        </script>

        <!-- Hide / unhide sidebar before it is displayed -->
        <script type="text/javascript">
            var html = document.querySelector('html');
            var sidebar = 'hidden';
            if (document.body.clientWidth >= 1080) {
                try { sidebar = localStorage.getItem('mdbook-sidebar'); } catch(e) { }
                sidebar = sidebar || 'visible';
            }
            html.classList.remove('sidebar-visible');
            html.classList.add("sidebar-" + sidebar);
        </script>

        <nav id="sidebar" class="sidebar" aria-label="Table of contents">
            <div class="sidebar-scrollbox">
                <ol class="chapter"><li class="chapter-item expanded "><a href="../../../intro.html"><strong aria-hidden="true">1.</strong> Introdução</a></li><li class="chapter-item expanded "><a href="../../../togaf.html"><strong aria-hidden="true">2.</strong> ToGAF O-AAF</a></li><li class="chapter-item expanded "><a href="../../../objetivo.html"><strong aria-hidden="true">3.</strong> Objetivo</a></li><li class="chapter-item expanded "><a href="../../../proposta.html"><strong aria-hidden="true">4.</strong> Proposta Técnica</a></li><li class="chapter-item expanded "><a href="../../../entrevistas.html"><strong aria-hidden="true">5.</strong> Entrevista</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../entrevista/arqsis.html"><strong aria-hidden="true">5.1.</strong> Arquitetura de Sistemas</a></li><li class="chapter-item expanded "><a href="../../../entrevista/seg.html"><strong aria-hidden="true">5.2.</strong> Segurança</a></li><li class="chapter-item expanded "><a href="../../../entrevista/infra.html"><strong aria-hidden="true">5.3.</strong> Infraestrutura</a></li><li class="chapter-item expanded "><a href="../../../entrevista/db.html"><strong aria-hidden="true">5.4.</strong> Dados</a></li><li class="chapter-item expanded "><a href="../../../entrevista/proj.html"><strong aria-hidden="true">5.5.</strong> Projetos</a></li></ol></li><li class="chapter-item expanded "><a href="../../../asis.html"><strong aria-hidden="true">6.</strong> AS-IS de Arquitetura</a></li><li class="chapter-item expanded "><a href="../../../mva.html"><strong aria-hidden="true">7.</strong> Arquitetura Mínima Viável</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../mva/mvadesign.html"><strong aria-hidden="true">7.1.</strong> Arquitetura de Design</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../mva/ad/adrs/adr001.html"><strong aria-hidden="true">7.1.1.</strong> ADR-001</a></li><li class="chapter-item expanded "><a href="../../../mva/ad/adrs/adr002.html"><strong aria-hidden="true">7.1.2.</strong> ADR-002</a></li><li class="chapter-item expanded "><a href="../../../mva/ad/adrs/adr003.html" class="active"><strong aria-hidden="true">7.1.3.</strong> ADR-003</a></li><li class="chapter-item expanded "><a href="../../../mva/ad/adrs/adr004.html"><strong aria-hidden="true">7.1.4.</strong> ADR-004</a></li><li class="chapter-item expanded "><a href="../../../mva/ad/adrs/adr005.html"><strong aria-hidden="true">7.1.5.</strong> ADR-005</a></li><li class="chapter-item expanded "><a href="../../../mva/ad/adrs/adr006.html"><strong aria-hidden="true">7.1.6.</strong> ADR-006</a></li><li class="chapter-item expanded "><a href="../../../mva/ad/adrs/adr007.html"><strong aria-hidden="true">7.1.7.</strong> ADR-007</a></li><li class="chapter-item expanded "><a href="../../../mva/ad/adrs/adr008.html"><strong aria-hidden="true">7.1.8.</strong> ADR-008</a></li><li class="chapter-item expanded "><a href="../../../mva/ad/adrs/adr009.html"><strong aria-hidden="true">7.1.9.</strong> ADR-009</a></li></ol></li><li class="chapter-item expanded "><a href="../../../mva/mvasol.html"><strong aria-hidden="true">7.2.</strong> Arquitetura de Solucao</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr001.html"><strong aria-hidden="true">7.2.1.</strong> ADR-001</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr002.html"><strong aria-hidden="true">7.2.2.</strong> ADR-002</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr003.html"><strong aria-hidden="true">7.2.3.</strong> ADR-003</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr004.html"><strong aria-hidden="true">7.2.4.</strong> ADR-004</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr005.html"><strong aria-hidden="true">7.2.5.</strong> ADR-005</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr006.html"><strong aria-hidden="true">7.2.6.</strong> ADR-006</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr007.html"><strong aria-hidden="true">7.2.7.</strong> ADR-007</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr008.html"><strong aria-hidden="true">7.2.8.</strong> ADR-008</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr009.html"><strong aria-hidden="true">7.2.9.</strong> ADR-009</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr010.html"><strong aria-hidden="true">7.2.10.</strong> ADR-010</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr011.html"><strong aria-hidden="true">7.2.11.</strong> ADR-011</a></li><li class="chapter-item expanded "><a href="../../../mva/as/adrs/adr012.html"><strong aria-hidden="true">7.2.12.</strong> ADR-012</a></li></ol></li></ol></li><li class="chapter-item expanded "><a href="../../../gov/intro.html"><strong aria-hidden="true">8.</strong> Governança de Arquitetura</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../gov/fase1.html"><strong aria-hidden="true">8.1.</strong> MGM Microservices Governance Maturity</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-001.html"><strong aria-hidden="true">8.1.1.</strong> ADR-001</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-002.html"><strong aria-hidden="true">8.1.2.</strong> ADR-002</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-003.html"><strong aria-hidden="true">8.1.3.</strong> ADR-003</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-004.html"><strong aria-hidden="true">8.1.4.</strong> ADR-004</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-005.html"><strong aria-hidden="true">8.1.5.</strong> ADR-005</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-006.html"><strong aria-hidden="true">8.1.6.</strong> ADR-006</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-007.html"><strong aria-hidden="true">8.1.7.</strong> ADR-007</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-008.html"><strong aria-hidden="true">8.1.8.</strong> ADR-008</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-009.html"><strong aria-hidden="true">8.1.9.</strong> ADR-009</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-010.html"><strong aria-hidden="true">8.1.10.</strong> ADR-010</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-011.html"><strong aria-hidden="true">8.1.11.</strong> ADR-011</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-012.html"><strong aria-hidden="true">8.1.12.</strong> ADR-012</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-013.html"><strong aria-hidden="true">8.1.13.</strong> ADR-013</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-014.html"><strong aria-hidden="true">8.1.14.</strong> ADR-014</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-015.html"><strong aria-hidden="true">8.1.15.</strong> ADR-015</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-016.html"><strong aria-hidden="true">8.1.16.</strong> ADR-016</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-017.html"><strong aria-hidden="true">8.1.17.</strong> ADR-017</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-018.html"><strong aria-hidden="true">8.1.18.</strong> ADR-018</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-019.html"><strong aria-hidden="true">8.1.19.</strong> ADR-019</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/ADR-020.html"><strong aria-hidden="true">8.1.20.</strong> ADR-020</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/Ferramental-AS-IS.html"><strong aria-hidden="true">8.1.21.</strong> Ferramental AS-IS</a></li><li class="chapter-item expanded "><a href="../../../gov/fase1/GAP-Analysis.html"><strong aria-hidden="true">8.1.22.</strong> GAP Analysis</a></li></ol></li><li class="chapter-item expanded "><a href="../../../gov/fase2.html"><strong aria-hidden="true">8.2.</strong> MGPD Microservices Governance Process Design</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../gov/fase2/Introdução.html"><strong aria-hidden="true">8.2.1.</strong> Introdução</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Ferramentas.html"><strong aria-hidden="true">8.2.2.</strong> Ferramentas</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Planejamento.html"><strong aria-hidden="true">8.2.3.</strong> Governança de Planejamento</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Planejamento/Política-de-Infraestrutura.html"><strong aria-hidden="true">8.2.3.1.</strong> Política de Infraestrutura</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Planejamento/Política-de-Arquitetura.html"><strong aria-hidden="true">8.2.3.2.</strong> Política de Arquitetura</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Planejamento/Política-de-Segurança.html"><strong aria-hidden="true">8.2.3.3.</strong> Política de Segurança</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Planejamento/Política-de-APIs.html"><strong aria-hidden="true">8.2.3.4.</strong> Política de APIs</a></li></ol></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Desenvolvimento.html"><strong aria-hidden="true">8.2.4.</strong> Governança de Desenvolvimento</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Desenvolvimento/Política-de-Desenvolvimento.html"><strong aria-hidden="true">8.2.4.1.</strong> Política de Desenvolvimento</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Desenvolvimento/Política-de-Qualidade-e-Métricas.html"><strong aria-hidden="true">8.2.4.2.</strong> Política de Qualidade e Métricas</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Desenvolvimento/Política-de-Testes.html"><strong aria-hidden="true">8.2.4.3.</strong> Política de Testes</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Desenvolvimento/Política-de-Construção.html"><strong aria-hidden="true">8.2.4.4.</strong> Política de Construção</a></li></ol></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Operação.html"><strong aria-hidden="true">8.2.5.</strong> Governança de Operação</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Operação/Política-de-Operação.html"><strong aria-hidden="true">8.2.5.1.</strong> Política de Operação</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Operação/Política-de-Versionamento.html"><strong aria-hidden="true">8.2.5.2.</strong> Política de Versionamento</a></li></ol></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Compartilhamento.html"><strong aria-hidden="true">8.2.6.</strong> Governança de Compartilhamento</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../gov/fase2/Governança-de-Compartilhamento/Política-de-Monitoramento-e-Métricas-de-APIs.html"><strong aria-hidden="true">8.2.6.1.</strong> Política de Monitoramento e Métricas de APIs</a></li></ol></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Modelos-de-Documentação.html"><strong aria-hidden="true">8.2.7.</strong> Modelos de Documentação</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="../../../gov/fase2/Modelos-de-Documentação/1.-Documento-de-Contrato-de-Microserviço.html"><strong aria-hidden="true">8.2.7.1.</strong> 1 Documento de Contrato de Microserviço</a></li><li class="chapter-item expanded "><a href="../../../gov/fase2/Modelos-de-Documentação/2.-Checklist-de-aprovação-para-implantação.html"><strong aria-hidden="true">8.2.7.2.</strong> 2 Checklist de Aprovação para Implantação</a></li></ol></li></ol></li></ol></li></ol>
            </div>
            <div id="sidebar-resize-handle" class="sidebar-resize-handle"></div>
        </nav>

        <div id="page-wrapper" class="page-wrapper">

            <div class="page">
                <div id="menu-bar-hover-placeholder"></div>
                <div id="menu-bar" class="menu-bar sticky bordered">
                    <div class="left-buttons">
                        <button id="sidebar-toggle" class="icon-button" type="button" title="Toggle Table of Contents" aria-label="Toggle Table of Contents" aria-controls="sidebar">
                            <i class="fa fa-bars"></i>
                        </button>
                        <button id="theme-toggle" class="icon-button" type="button" title="Change theme" aria-label="Change theme" aria-haspopup="true" aria-expanded="false" aria-controls="theme-list">
                            <i class="fa fa-paint-brush"></i>
                        </button>
                        <ul id="theme-list" class="theme-popup" aria-label="Themes" role="menu">
                            <li role="none"><button role="menuitem" class="theme" id="light">Light (default)</button></li>
                            <li role="none"><button role="menuitem" class="theme" id="rust">Rust</button></li>
                            <li role="none"><button role="menuitem" class="theme" id="coal">Coal</button></li>
                            <li role="none"><button role="menuitem" class="theme" id="navy">Navy</button></li>
                            <li role="none"><button role="menuitem" class="theme" id="ayu">Ayu</button></li>
                        </ul>
                        <button id="search-toggle" class="icon-button" type="button" title="Search. (Shortkey: s)" aria-label="Toggle Searchbar" aria-expanded="false" aria-keyshortcuts="S" aria-controls="searchbar">
                            <i class="fa fa-search"></i>
                        </button>
                    </div>

                    <h1 class="menu-title">Arquitetura Mínima Viável</h1>

                    <div class="right-buttons">
                        <a href="../../../print.html" title="Print this book" aria-label="Print this book">
                            <i id="print-button" class="fa fa-print"></i>
                        </a>
                    </div>
                </div>

                <div id="search-wrapper" class="hidden">
                    <form id="searchbar-outer" class="searchbar-outer">
                        <input type="search" id="searchbar" name="searchbar" placeholder="Search this book ..." aria-controls="searchresults-outer" aria-describedby="searchresults-header">
                    </form>
                    <div id="searchresults-outer" class="searchresults-outer hidden">
                        <div id="searchresults-header" class="searchresults-header"></div>
                        <ul id="searchresults">
                        </ul>
                    </div>
                </div>
                <!-- Apply ARIA attributes after the sidebar and the sidebar toggle button are added to the DOM -->
                <script type="text/javascript">
                    document.getElementById('sidebar-toggle').setAttribute('aria-expanded', sidebar === 'visible');
                    document.getElementById('sidebar').setAttribute('aria-hidden', sidebar !== 'visible');
                    Array.from(document.querySelectorAll('#sidebar a')).forEach(function(link) {
                        link.setAttribute('tabIndex', sidebar === 'visible' ? 0 : -1);
                    });
                </script>

                <div id="content" class="content">
                    <main>
                        <p><img src="../../../img/logo-valecard.png" alt="Screenshot" /></p>
<h2 id="713-adr-003---administrar-os-contêineres-através-de-serviços-gerenciáveis--service-mesh"><a class="header" href="#713-adr-003---administrar-os-contêineres-através-de-serviços-gerenciáveis--service-mesh">7.1.3. ADR-003 - Administrar os Contêineres através de Serviços Gerenciáveis ( Service Mesh).</a></h2>
<hr />
<p>I. Problema: </p>
<blockquote>
<p>Como administrar os aplicativos do lado do servidor de modo a promover uma solução gerenciável, de baixo acoplamento , baixo impacto na implantação, alta disponibilidade , elasticidade e resiliência?</p>
</blockquote>
<p>II. Decisão/ Razão de Escolha: </p>
<blockquote>
<ul>
<li>Para endereçar esse problema foi escolhido um paradigma de malha de serviços(<b> Service Mesh </b>).</li>
<li>As Razões para essa escolha foram:
<ul>
<li>Soluções de <b> Service Mesh </b> permite aplicar uma gerência avançada sobre os contêineres.</li>
<li>Solução de <b> Service Mesh </b> permite realizar a telemetria , balanceamento baseado em tráfego de informações , gestão do ciclo de vida do conteiner , gestão da implantação com diversos tipos de estratégias de deploy.</li>
</ul>
</li>
</ul>
</blockquote>
<p>III. Status:</p>
<blockquote>
<p>Pendente de Aprovação.</p>
</blockquote>
<p>IV. Épico: </p>
<blockquote>
<p>Service Mesh.</p>
</blockquote>
<p>V. Suposiçoes:</p>
<blockquote>
<ul>
<li>Valecard necessita de uma ferramenta para orquestrar os seus contêineres de microserviços.</li>
<li>Essa ferramenta precisa garantir a resiliência, escalabilidade e elasticidades dos mesmos.</li>
<li>Essa ferramenta precisa garantir o monitoramento de cada container através do uso de telemetria e permitir ,,através de politicas, a tomada de decisão correta para garantir a resiliência do mesmo.</li>
<li>Essa ferramenta deve permitir a estratégia de implantações Blue x Green.</li>
<li>Essa ferramenta deve permitir a implementação de políticas de circuit break e control loops baseados na observância de cada container.</li>
</ul>
</blockquote>
<p>VI. Visões:<br>
<img src="../img/adr003.png" alt="Screenshot" /></p>
<p>VII. Requisitos não funcionais:</p>
<blockquote>
<ul>
<li>Resiliência.</li>
<li>Observância.</li>
<li>Telemetria.</li>
<li>Implantação Blue x Green.</li>
<li>Circutit Break.</li>
<li>Control Loop.</li>
</ul>
</blockquote>
<p>VIII. Implicações: </p>
<blockquote>
<ul>
<li>Capacitação da equipe de desenvolvimento da Valecard para atuar com o produto.</li>
<li>Capacitação do Centro de Excelência na organização e governança dos Pods.
<ul>
<li>Criação das politicas de implantações Blue x Green</li>
<li>Ciclo de vida do Pod.</li>
<li>Monitoramento preventivo dos Pods através do Control Plane.</li>
</ul>
</li>
</ul>
</blockquote>
<p>IX. Decisões relacionadas:</p>
<blockquote>
<p>Não há.</p>
</blockquote>
<p>X. Driver de Negócio: </p>
<blockquote>
<ul>
<li>Permitir que a Valecard disponibilize suas funções de negócios com resiliência e performática:
<ul>
<li>Realizar o Cadastro do Cliente.</li>
<li>Gestão dos Abastescimentos</li>
<li>Gestão dos Benéficios</li>
</ul>
</li>
</ul>
</blockquote>
<p>XI. Artefatos Relacionados: </p>
<blockquote>
<p>Não há.</p>
</blockquote>

                    </main>

                    <nav class="nav-wrapper" aria-label="Page navigation">
                        <!-- Mobile navigation buttons -->
                            <a rel="prev" href="../../../mva/ad/adrs/adr002.html" class="mobile-nav-chapters previous" title="Previous chapter" aria-label="Previous chapter" aria-keyshortcuts="Left">
                                <i class="fa fa-angle-left"></i>
                            </a>
                            <a rel="next" href="../../../mva/ad/adrs/adr004.html" class="mobile-nav-chapters next" title="Next chapter" aria-label="Next chapter" aria-keyshortcuts="Right">
                                <i class="fa fa-angle-right"></i>
                            </a>
                        <div style="clear: both"></div>
                    </nav>
                </div>
            </div>

            <nav class="nav-wide-wrapper" aria-label="Page navigation">
                    <a rel="prev" href="../../../mva/ad/adrs/adr002.html" class="nav-chapters previous" title="Previous chapter" aria-label="Previous chapter" aria-keyshortcuts="Left">
                        <i class="fa fa-angle-left"></i>
                    </a>
                    <a rel="next" href="../../../mva/ad/adrs/adr004.html" class="nav-chapters next" title="Next chapter" aria-label="Next chapter" aria-keyshortcuts="Right">
                        <i class="fa fa-angle-right"></i>
                    </a>
            </nav>

        </div>

        <script type="text/javascript">
            window.playground_copyable = true;
        </script>
        <script src="../../../elasticlunr.min.js" type="text/javascript" charset="utf-8"></script>
        <script src="../../../mark.min.js" type="text/javascript" charset="utf-8"></script>
        <script src="../../../searcher.js" type="text/javascript" charset="utf-8"></script>
        <script src="../../../clipboard.min.js" type="text/javascript" charset="utf-8"></script>
        <script src="../../../highlight.js" type="text/javascript" charset="utf-8"></script>
        <script src="../../../book.js" type="text/javascript" charset="utf-8"></script>

        <!-- Custom JS scripts -->
    </body>
</html>
